﻿using System.ComponentModel;

public class Enemy : INotifyPropertyChanged
{
    private int health;
    public int Health
    {
        get { return health; }
        set
        {
            health = value;
            ValueChanged("Health");
        }

    }

    public bool IsAlive { get { return health > 0; } }

    public int MaxHealth { get; set; }
    public int Damage { get; set; }
    public float Speed { get; set; }
    public int HealthRegen { get; set; }
    public int Armor { get; set; }
    public int LightResistance { get; set; }
    public int ShadowResistance { get; set; }
    public eEnemy.EnemyType Type { get; set; }

    public event PropertyChangedEventHandler PropertyChanged;

    public Enemy(int health, int damage, int healthRegen, int armor,
        int lightResistance, int shadowResistance, float speed, eEnemy.EnemyType type)
    {
        Health = health;
        MaxHealth = health;
        Damage = damage;
        HealthRegen = healthRegen;
        Armor = armor;
        LightResistance = lightResistance;
        ShadowResistance = shadowResistance;
        Speed = speed;
        Type = type;
    }

    private void ValueChanged(string property)
    {
        if (PropertyChanged != null)
            PropertyChanged(this, new PropertyChangedEventArgs(property));
    }
}
