﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class EndGameBehaviour : MonoBehaviour
{
    private Canvas canvas;
    public Text header, scoreText;
    private GameMaster gameMaster;

	// Use this for initialization
	void Start ()
	{
	    canvas = GetComponent<Canvas>();
        // it's not visible from the start
	    canvas.enabled = false;
	    gameMaster = GameObject.Find("_GameMaster").GetComponent<GameMaster>();
	}
	
	// Update is called once per frame
	void Update () 
    {
        // player is dead
	    if (!gameMaster.Alive() && !canvas.enabled)
	    {
            OnGameEnd();
	        header.text = "You have lost hte game";
	        canvas.enabled = true;
            // also pause the game, we don't need any moving objects anymore
	        Time.timeScale = 0;
	    }

        // player won
        if (gameMaster.AllEnemiesKilled() && !canvas.enabled)
        {
            OnGameEnd();
            header.text = "You have won the game";
            canvas.enabled = true;
            // also pause the game, we don't need any moving objects anymore
            Time.timeScale = 0;
        }
	}

    private void OnGameEnd()
    {
        scoreText.text = gameMaster.Score.ToString();
    }

    public void MainMenu()
    {
        // unpause the game
        Time.timeScale = 1;

		SceneManager.LoadScene("Menu");
    }

    public void Quit()
    {
        Application.Quit();
    }
}
