﻿using UnityEngine;
using System.Collections;
using UnityEngine.SceneManagement;

public class GameMenuBehaviour : MonoBehaviour
{
    private Canvas canvas;

    void Start()
    {
        canvas = GetComponent<Canvas>();
        canvas.enabled = false;
    }

    void Update()
    {
        if (Input.GetKeyDown(KeyCode.Escape))
        {
            canvas.enabled = !canvas.enabled;
        }
    }

    public void ReturnToMainMenu()
    {
        // return game speed to the normal
        // in case time was faster
        Time.timeScale = 1;

		SceneManager.LoadScene("Menu");
    }

    public void CloseGameMenu()
    {
        canvas.enabled = false;
    }

    public void ExitGame()
    {
        Application.Quit();
    }
}
