﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class WaveListGUI : MonoBehaviour
{
    [SerializeField]
    private GameObject waveTemplate;
    private SpawnerBehaviour spawner;

    private void Awake()
    {
        spawner = GameObject.Find("Spawner").GetComponent<SpawnerBehaviour>();
        spawner.WavesGenerated += Spawner_WavesGenerated;
        spawner.WaveEnded += Spawner_WaveEnded;
    }

    private void Spawner_WaveEnded(object sender, System.EventArgs e)
    {
        Debug.Log("Removing GUI wave.");
        GameObject item = GameObject.Find(string.Format("Wave{0}", spawner.CurrentWave.Number));
        if (item != null)
            Destroy(item);
    }

    private void Spawner_WavesGenerated(object sender, System.EventArgs e)
    {
        Debug.Log("Generating GUI waves.");
        foreach (Wave item in spawner.Waves)
        {
            GameObject wave = Instantiate(waveTemplate);
            wave.name = string.Format("Wave{0}", item.Number);
            wave.SetActive(true);

            wave.GetComponent<WaveGUI>().SetWave(item.Number, ((eEnemy.EnemyType)item.EnemyType).ToString(), item.Size, item.EnemyType);

            wave.transform.SetParent(waveTemplate.transform.parent, false);
        }
    }

    /*private void OnEnable()
    {
        EventManager.StartListening("WavesGenerated", GenerateList);
        EventManager.StartListening("WaveEnded", RemoveWave);
    }

    private void OnDisable()
    {
        EventManager.StopListening("WavesGenerated", GenerateList);
        EventManager.StopListening("WaveEnded", RemoveWave);
    }*/
}
