﻿using System;
using System.Linq;
using UnityEngine;
using UnityEngine.UI;

public class GameMaster : MonoBehaviour
{
    public Text coinsLabel;
    public Text healthLabel;
    public Text scoreLabel;
    public GameObject Core;

    public int MaxHealth { get; private set; }

    private int health;
    public int Health
    {
        get { return health; }
        set
        {
            health = value;
            healthLabel.text = Convert.ToString(health);
        }
    }

    private int coins;
    public int Coins
    {
        get { return coins; }
        set
        {
            coins = value;
            coinsLabel.text = Convert.ToString(coins);
        }
        
    }

    private int score;
    public int Score
    {
        get { return score; }
        set
        {
            score = value;
            scoreLabel.text = Convert.ToString(score);
        }

    }

    private GameInfo gameInfo;
    private SpawnerBehaviour spawner;

    void Start()
    {
        // load game settings
        gameInfo = GameObject.Find("_GameInfo").GetComponent<GameInfo>();
        spawner = GameObject.Find("Spawner").GetComponent<SpawnerBehaviour>();

        Health = 100;
        Coins = gameInfo.Coins;
        Score = 0;
        MaxHealth = Health;
    }

    public void GenerateCore()
    {
        TileMapGraphics tgMap = GameObject.Find("TileMap").GetComponent<TileMapGraphics>();
		Tile finishTile = tgMap.Map.FindTile(x =>
            x.Position.x == tgMap.sizeX - 1
            &&
            x.Type == eTileType.Texture.Path);

        Instantiate(Core, new Vector3(finishTile.Position.x * tgMap.tileSize, 
            -finishTile.Position.y * tgMap.tileSize, 0), Quaternion.identity);

        Debug.Log("Done generating Core!");
    }

    public bool Alive()
    {
        return health > 0;
    }

    public bool AllEnemiesKilled()
    {
        return (spawner.AllWavesFinished() && !GameObject.FindGameObjectsWithTag("Enemy").Any());
    }
}