﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(BoxCollider2D))]
public class ProjectileBehaviour : MonoBehaviour
{
    public GameObject ExplosionAnimation;
    public float Speed = 10;
    
    private GameObject target;
    private int damage;
    private Transform tra;

    private BoxCollider2D box;

    public void SetProjectile(GameObject target, int damage)
    {
        this.target = target;
        this.damage = damage;
        tra = transform;
        box = GetComponent<BoxCollider2D>();
        box.isTrigger = true;

        Debug.Log("Projectile was set!");
    }
	
	// Update is called once per frame
	void Update()
	{
	    if (target != null)
	        tra.position = Vector3.MoveTowards(tra.position, target.transform.position, Speed * Time.deltaTime);
	    else
	        Destroy(gameObject);
	}

    void OnTriggerEnter2D(Collider2D coll)
    {
        if (coll.gameObject.tag == "Enemy")
        {
            Debug.Log("Hitted the enemy");

            // spawn explosion animation
            Instantiate(ExplosionAnimation, coll.gameObject.transform.position, Quaternion.identity);

            EnemyBehaviour enemyBehaviour = coll.gameObject.GetComponent<EnemyBehaviour>();
            enemyBehaviour.Enemy.Health -= damage;
            enemyBehaviour.OnEnemyHitted();

            Destroy(gameObject);
        }
    }
}
