﻿
public class AlchemyTower : Tower
{
	public int PoisonDamage { get; set; }
	public int OnHitHealthReduction { get; set; }
	public int OnHitRegenReduction { get; set; }
	public int CharmChance { get; set; }

	public AlchemyTower(float range, int minDamage, int maxDamage, float fireRate,
		int upgradeCost, int poisonDamage, int onHitHealthReduction, int onHitRegenReduction,
		int charmChance)
		: base(range, minDamage, maxDamage, fireRate, upgradeCost, eTower.TowerType.AlchemyTower)
	{
		PoisonDamage         = poisonDamage;
		OnHitHealthReduction = onHitHealthReduction;
		OnHitRegenReduction  = onHitRegenReduction;
		CharmChance          = charmChance;
	}

	/// <summary>
	/// Constructor that will create tower with base stats.
	/// Using AlchemyTowerUpgrades base stats.
	/// </summary>
	public AlchemyTower()
		: base(AlchemyTowerUpgrades.Range, AlchemyTowerUpgrades.MinDamage, AlchemyTowerUpgrades.MaxDamage,
			AlchemyTowerUpgrades.FireRate, AlchemyTowerUpgrades.LvlOneUpgradeCost, eTower.TowerType.AlchemyTower)
	{
		PoisonDamage = AlchemyTowerUpgrades.PoisonDamage;
		OnHitHealthReduction = AlchemyTowerUpgrades.OnHitHealthReduction;
		OnHitRegenReduction = AlchemyTowerUpgrades.OnHitRegenReduction;
		CharmChance = AlchemyTowerUpgrades.CharmChance;
	}

	public void UpgradeTower(AlchemyTowerUpgrade upgrade)
	{
        UpgradeCost = AlchemyTowerUpgrades.GetNextLevelUpgradeCost(this);

        Range = upgrade.Range;
		MinDamage = upgrade.MinDamage;
		MaxDamage = upgrade.MaxDamage;
		FireRate = upgrade.FireRate;
		PoisonDamage = upgrade.PoisonDamage;
		OnHitHealthReduction = upgrade.OnHitHealthReduction;
		OnHitRegenReduction = upgrade.OnHitRegenReduction;
		CharmChance = upgrade.CharmChance;
	}
}
