﻿
public class BeamTower : Tower
{
	public int LightIgnore { get; set; }
	public int ShadowIgnore { get; set; }
	public int OnHitResReduction { get; set; }

	public BeamTower(float range, int minDamage, int maxDamage, float fireRate,
		int upgradeCost, int lightIgnore, int shadowIgnore, int onHitResReduction)
		: base(range, minDamage, maxDamage, fireRate, upgradeCost, eTower.TowerType.BeamTower)
	{
		LightIgnore       = lightIgnore;
		ShadowIgnore      = shadowIgnore;
		OnHitResReduction = onHitResReduction;
	}

	/// <summary>
	/// Constructor that will create tower with base stats.
	/// Using BeamTowerUpgrades base stats.
	/// </summary>
	public BeamTower()
		: base (BeamTowerUpgrades.Range, BeamTowerUpgrades.MinDamage, BeamTowerUpgrades.MaxDamage,
			BeamTowerUpgrades.FireRate, BeamTowerUpgrades.LvlOneUpgradeCost, eTower.TowerType.BeamTower)
	{
		LightIgnore       = BeamTowerUpgrades.LightIgnore;
		ShadowIgnore      = BeamTowerUpgrades.ShadowIgnore;
		OnHitResReduction = BeamTowerUpgrades.OnHitResReduction;
	}

	public void UpgradeTower(BeamTowerUpgrade upgrade)
	{
        UpgradeCost = BeamTowerUpgrades.GetNextLevelUpgradeCost(this);

        Range             = upgrade.Range;
		MinDamage         = upgrade.MinDamage;
		MaxDamage         = upgrade.MaxDamage;
		FireRate          = upgrade.FireRate;
		LightIgnore       = upgrade.LightIgnore;
		ShadowIgnore      = upgrade.ShadowIgnore;
		OnHitResReduction = upgrade.OnHitResReduction;
	}
}
