﻿
public class GoldMine : Tower
{
	public int GoldPerSec { get; set; }
	public bool IsEnahnced { get; private set; }

	public GoldMine(int upgradeCost, int goldPercSec, bool isEnhanced)
		: base(0, 0, 0, 0, upgradeCost, eTower.TowerType.GoldMine)
	{
		GoldPerSec = goldPercSec;
		IsEnahnced = isEnhanced;
	}

	/// <summary>
	/// Constructor that will create tower with base stats.
	/// Using GoldMineUpgrades base stats.
	/// </summary>
	public GoldMine()
		: base(0, 0, 0, 0, GoldMineUpgrades.LvlOneUpgradeCost, eTower.TowerType.GoldMine)
	{
		GoldPerSec = GoldMineUpgrades.GoldPercSec;
	}

	public void UpgradeTower(GoldMineUpgrade upgrade)
	{
        UpgradeCost = GoldMineUpgrades.GetNextLevelUpgradeCost(this);

		GoldPerSec  = upgrade.GoldPerSec;
	}
}

