﻿
public class HunterTower : Tower
{
	public int ArmorIgnore { get; set; }
	public int OnHitArmorReduction { get; set; }
	public int MinAoeDamage { get; set; }
	public int MaxAoeDamage { get; set; }

	public HunterTower(float range, int minDamage, int maxDamage, float fireRate,
		int upgradeCost, int armorIgnore, int onHitArmorReduction, int minAoeDamage,
		int maxAoeDamage)
		: base(range, minDamage, maxDamage, fireRate, upgradeCost, eTower.TowerType.HunterTower)
	{
		ArmorIgnore         = armorIgnore;
		OnHitArmorReduction = onHitArmorReduction;
		MinAoeDamage        = minAoeDamage;
		MaxAoeDamage        = maxAoeDamage;
	}

	/// <summary>
	/// Constructor that will create tower with base stats.
	/// Using AlchemyTowerUpgrades base stats.
	/// </summary>
	public HunterTower()
		: base (HunterTowerUpgrades.Range, HunterTowerUpgrades.MinDamage, HunterTowerUpgrades.MaxDamage,
			HunterTowerUpgrades.FireRate, HunterTowerUpgrades.LvlOneUpgradeCost, eTower.TowerType.HunterTower)
	{
		ArmorIgnore         = HunterTowerUpgrades.ArmorIgnore;
		OnHitArmorReduction = HunterTowerUpgrades.OnHitArmorReduction;
		MinAoeDamage        = HunterTowerUpgrades.MinAoeDamage;
		MaxAoeDamage        = HunterTowerUpgrades.MaxAoeDamage;
	}

	public void UpgradeTower(HunterTowerUpgrade upgrade)
	{
        UpgradeCost = HunterTowerUpgrades.GetNextLevelUpgradeCost(this);

        Range               = upgrade.Range;
		MinDamage           = upgrade.MinDamage;
		MaxDamage           = upgrade.MaxDamage;
		FireRate            = upgrade.FireRate;
		ArmorIgnore         = upgrade.ArmorIgnore;
		OnHitArmorReduction = upgrade.OnHitArmorReduction;
		MinAoeDamage        = upgrade.MinAoeDamage;
		MaxAoeDamage        = upgrade.MaxAoeDamage;
	}
}
