﻿using UnityEngine;

public class Tile
{
    public Vector2 Position { get; private set; }

	private bool canBuildOn;
    public bool CanBuildOn { get { return canBuildOn; } }
	public bool IsOccupied { get; set; }

	private eTileType.Texture type;
	public eTileType.Texture Type
	{
		get { return type; }
		set
		{
			type = value;
			switch (type)
			{
				case eTileType.Texture.Empty:
					canBuildOn = true;
					break;
				case eTileType.Texture.Tree:
					canBuildOn = false;
					break;
				case eTileType.Texture.GoldVein:
					canBuildOn = true;
					break;
				case eTileType.Texture.Path:
					canBuildOn = false;
					break;
				case eTileType.Texture.Obstacle:
					canBuildOn = false;
					break;
				case eTileType.Texture.Ruins:
					canBuildOn = true;
					break;
			}
		}
	}

	public Tile(Vector2 position)
    {
		Position   = position;
		Type       = eTileType.Texture.Empty;
		IsOccupied = false;
	}

    public Tile(Vector2 position, eTileType.Texture tileType)
    {
        Position   = position;
        Type       = tileType;
		IsOccupied = false;
    }
}
